--***********************************************************
--**                       BitBraven                       **
--***********************************************************

BC_Client = {}
BC_Client.camouflaged = false
BC_Client.remainingTime = 0

local onClothingUpdated = function(playerObj)
    local visual = playerObj:getHumanVisual()
    local bodyBlood = 0
    local bodyDirt = 0

    for i=1,BloodBodyPartType.MAX:index() do
        local part = BloodBodyPartType.FromIndex(i-1)
        bodyBlood = bodyBlood + visual:getBlood(part)
        bodyDirt = bodyDirt + visual:getDirt(part)
    end

    if bodyBlood > 1 then return end
    if not BC_Client.camouflaged then return end
    BC_Client.RemovePlayerCamouflage()
end

local everyTenMinutes = function()

    if BC_Client.camouflaged ~= true then return end
    BC_Client.remainingTime = BC_Client.remainingTime - 1

    if BC_Client.remainingTime <= 0 then
        BC_Client.RemovePlayerCamouflage()
    elseif playerTime == 1 then
        getPlayer():Say(getText("IGUI_CamouflageLosing"))
    end
end

local onZombieUpdate = function(zombie)

    if not zombie:getTarget() then return end
    if BC_Client.camouflaged ~= true then return end

    local playerObj = getPlayer()
    if zombie:getTarget() == playerObj then

        local distance = BB_Cammo_Utils.DistanceBetween(playerObj, zombie)

        if distance > SandboxVars.Camouflage.MinDistance then
            zombie:setUseless(true)
            zombie:setTarget(nil)

            BB_Cammo_Utils.DelayFunction(function()
                zombie:setUseless(false)
            end, SandboxVars.Camouflage.StunDuration, true)
        else
            BC_Client.RemovePlayerCamouflage()
        end
    end
end

BC_Client.AddBloodToPlayerPart = function(playerObj, part)
    playerObj:getHumanVisual():setBlood(part, 1)
end

BC_Client.CamouflagePlayer = function(playerObj)

    -- Clothing blood
    local wornItems = playerObj:getWornItems()

    for i = 0, wornItems:size() - 1 do
        local item = wornItems:get(i):getItem()
        if item:IsClothing() and item:getFabricType() and not item:isHidden() then

            local coveredParts = BloodClothingType.getCoveredParts(item:getBloodClothingType())
            if coveredParts then
                for j=0,coveredParts:size()-1 do
                    item:setBlood(coveredParts:get(j), 60)
                end
            end

            item:setBloodLevel(60)
        end
    end

    -- Player blood
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.Head)
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.Neck)
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.Back)
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.Groin)

    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.Torso_Upper)
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.Torso_Lower)

    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.UpperArm_L)
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.UpperArm_R)

    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.ForeArm_L)
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.ForeArm_R)

    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.Hand_L)
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.Hand_R)

    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.UpperLeg_L)
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.UpperLeg_R)

    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.LowerLeg_L)
    BC_Client.AddBloodToPlayerPart(playerObj, BloodBodyPartType.LowerLeg_R)
    -- End of Player blood

    playerObj:resetModelNextFrame()
    playerObj:setZombiesDontAttack(true)
	sendClothing(playerObj)
	triggerEvent("OnClothingUpdated", playerObj)

    local bodyDamage = playerObj:getBodyDamage()
    bodyDamage:setFoodSicknessLevel(bodyDamage:getFoodSicknessLevel() + SandboxVars.Camouflage.Nausea)

    BC_Client.camouflaged = true
    BC_Client.remainingTime = BC_Client.remainingTime + (SandboxVars.Camouflage.CammoDuration / 10)
end

BC_Client.RemovePlayerCamouflage = function()
    BC_Client.camouflaged = false
    BC_Client.remainingTime = 0
    local playerObj = getPlayer()
    playerObj:setZombiesDontAttack(false)
    playerObj:Say(getText("IGUI_CamouflageLost"))
end

Events.EveryTenMinutes.Add(everyTenMinutes)
Events.OnZombieUpdate.Add(onZombieUpdate)
Events.OnClothingUpdated.Add(onClothingUpdated)